package directory.passive.markov;

import java.util.LinkedHashMap;
import java.util.Map.Entry;

// FIXME rename
public class Lookup {

	public static final Lookup empty = new Lookup() {
		public Token forRandom(double random) {
			return Token.EMPTY;
		}
	};

	public Lookup() {
	}

	private final LinkedHashMap<Token, Integer> tokens = new LinkedHashMap<Token, Integer>();

	private int getTotalCounts() {
		return tokens.values().stream().mapToInt(i -> i.intValue()).sum();
	}

	public void add(Token t) {
		Integer i = tokens.getOrDefault(t, 0);
		tokens.put(t, i + 1);
	}

	public Token forRandom(double random) {
		int id = (int) Math.floor(random * getTotalCounts());
		int i = 0;
		for (Entry<Token, Integer> entry : tokens.entrySet()) {
			i += entry.getValue();
			if (id < i) {
				return entry.getKey();
			}
		}
		throw new IllegalStateException(String.format(
				"failed to find a random token with seed %d within %s", id,
				this));

	}

	@Override
	public String toString() {
		return "Lookup [tokens=" + tokens + "]";
	}

}
