package directory.passive.markov;

public class Token {

	public static final Token START = new SpecialToken();
	public static final Token END = new SpecialToken();
	protected static final Token EMPTY = new SpecialToken();

	public Token(String content) {
		super();
		this.content = content;
	}

	String content;

	@Override
	public String toString() {
		if (this == END) {
			return "Token <END>";
		}
		if (this == START) {
			return "TOKEN <START>";
		}
		if (this == EMPTY)
			return "TOKEN <empty>";
		return "Token [content=" + content + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((content == null) ? 0 : content.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null)
			return false;
		if (this == START)
			return false;
		if (this == END)
			return false;
		if (this == EMPTY)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Token other = (Token) obj;
		if (content == null) {
			if (other.content != null)
				return false;
		} else if (!content.equals(other.content))
			return false;
		return true;
	}

	public String render(String prefix) {
		return prefix + content;
	}

	private static class SpecialToken extends Token {

		public SpecialToken() {
			super("");
		}

		@Override
		public String render(String prefix) {
			return "";
		}

	}

}
